<template>
  <div class="sw-gs-offcanvas-like-list sw-side-like-list">
    <SwPluginSlot name="gs-offcanvas-like-list-button">
      <SwButton v-if="(isGuide && clients.length === 1) || isSelfService"
                class="sw-gs-go-to-like-list-btn color-light is-small"
                :title="$t('Go to like list page')"
                @click="openDynamicPage({
                  type: 'likeList',
                  opened: true
                })"
      >
        <template v-if="isSelfService">
          {{ $t('Go to like list page') }}
        </template>
        <template v-else>
          {{ $t('Take user to like list page') }}
        </template>
        <SfIcon icon="arrow_right" size="sm"/>
      </SwButton>
    </SwPluginSlot>

    <div v-if="likedCount > 0"
         key="my-like-list"
         class="sw-gs-offcanvas-like-list-inner">
      <SwPluginSlot name="gs-offcanvas-like-list-products-before" />
      <transition-group name="fade" tag="div" class="sw-gs-offcanvas-like-list-products">
        <SwGsOffcanvasCollectionProduct
          v-for="product in likeList"
          :key="product.id"
          :product="product"
        />
      </transition-group>
      <SwPluginSlot name="gs-offcanvas-like-list-products-after" />
    </div>
    <div v-else key="empty-like-list" class="sw-gs-offcanvas-like-list-empty">
      <SfHeading
        :title="$t('Like list is empty')"
        :level="2"
        class="empty-like-list__heading"
      />
    </div>
  </div>
</template>

<script lang="ts">
  import { SfHeading, SfIcon } from "@storefront-ui/vue"
  import SwButton from "@/components/atoms/SwButton.vue"
  import SwPluginSlot from "sw-plugins/SwPluginSlot.vue"
  import {useLikeList} from "../../logic/composables/useLikeList";
  import SwGsOffcanvasCollectionProduct from "./SwGsOffcanvasCollectionProduct.vue";
  import {useState} from "../../logic/composables/useState";
  import {useAppointment} from "../../logic/composables/useAppointment";
  import {useDynamicPage} from "../../logic/composables/useDynamicPage";

  export default {
    name: "SwGsOffcanvasLikeList",
    components: {
      SfIcon,
      SwGsOffcanvasCollectionProduct,
      SfHeading,
      SwPluginSlot,
      SwButton
    },
    setup() {
      const {isGuide, isSelfService} = useAppointment();
      const {clients} = useState();
      const {
        likeList,
        likedCount
      } = useLikeList();
      const {
        openDynamicPage
      } = useDynamicPage();

      return {
        isGuide,
        isSelfService,
        clients,
        likeList,
        likedCount,
        openDynamicPage
      }
    }
  }
</script>
<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-side-like-list {
    --property-name-font-size: var(--font-size--lg);
    --property-value-font-size: var(--font-size--lg);
    --sidebar-bottom: var(--bottom-navigation-height, 0);
    --sidebar-bottom-padding: var(--spacer-sm) var(--spacer-sm) var(--spacer-xl);

    & > * {
      --sidebar-content-padding: 0 var(--spacer-xs) var(--spacer-xs)
      var(--spacer-xs);
    }
    @include for-desktop {
      --sidebar-bottom: 0;
      & > * {
        --sidebar-bottom-padding: var(--spacer-base);
        --sidebar-content-padding: 0 var(--spacer-base) var(--spacer-base)
        var(--spacer-base);
      }
    }
  }

  .sw-gs-offcanvas-like-list-inner {
    flex: 1;
    display: flex;
    flex-direction: column;
  }

  .sw-gs-go-to-like-list-btn {
    margin-bottom: var(--spacer-base);
    padding-left: var(--spacer-sm);
    padding-right: var(--spacer-sm);

    ::v-deep .sf-icon {
      margin-left: var(--spacer-xs);
    }
  }

  .sw-gs-offcanvas-like-list-products {
    display: flex;
    flex-wrap: wrap;
    margin-left: calc(-1 * var(--spacer-2xs));
    margin-right: calc(-1 * var(--spacer-2xs));

    ::v-deep .sw-gs-offcanvas-collection-product {
      flex-wrap: wrap;
      position: relative;
      width: 100%;
      flex: 0 0 50%;
      max-width: 50%;
      margin-bottom: 30px;
    }

    ::v-deep .sw-product-card:not(:hover) {
      .sw-gs-product-card-like-btn {
        &.is-on-list {
          @include for-desktop {
            opacity: 0;
          }
        }
      }
    }
  }

  .sw-gs-offcanvas-like-list-empty {
    --heading-description-margin: 0 0 var(--spacer-xl) 0;
    --heading-title-margin: var(--spacer-base) 0;
    --heading-title-color: var(--c-primary);
    --heading-title-font-weight: var(--font-weight--semibold);
    display: flex;
    flex: 1;
    align-items: center;
    flex-direction: column;
  }
</style>
